diff -ru hurd-0.0/ufs/inode.c hurd-0.1/ufs/inode.c
--- hurd-0.0/ufs/inode.c	Mon Jul 29 12:40:17 1996
+++ hurd-0.1/ufs/inode.c	Fri Aug 16 18:52:19 1996
@@ -20,6 +20,7 @@
 #include <unistd.h>
 #include <stdio.h>
 #include <netinet/in.h>
+#include <fcntl.h>
 
 #define	INOHSZ	512
 #if	((INOHSZ&(INOHSZ-1)) == 0)
@@ -68,6 +69,7 @@
 
   dn->number = inum;
   dn->dirents = 0;
+  dn->dir_idx = 0;
 
   rwlock_init (&dn->allocptrlock);
   dn->dirty = 0;
@@ -497,8 +499,8 @@
 diskfs_set_statfs (struct statfs *st)
 {
   st->f_type = FSTYPE_UFS;
-  st->f_bsize = sblock->fs_bsize;
-  st->f_blocks = sblock->fs_dsize * sblock->fs_frag;
+  st->f_bsize = sblock->fs_fsize;
+  st->f_blocks = sblock->fs_dsize;
   st->f_bfree = (sblock->fs_cstotal.cs_nbfree * sblock->fs_frag
 		 + sblock->fs_cstotal.cs_nffree);
   st->f_bavail = ((sblock->fs_dsize * (100 - sblock->fs_minfree) / 100)
@@ -721,6 +723,127 @@
   mutex_unlock (&np->lock);
   
   return 0;
+}
+
+/* Must be exactly 28 bytes long */
+struct ufs_fhandle
+{
+  int filler1;
+  ino_t inum;
+  long gen;
+  int filler2[4];
+};
+
+/* Return an NFS file handle */
+
+error_t
+diskfs_S_file_getfh (struct protid *cred,
+		     char **fh,
+		     u_int *fh_len)
+{
+  struct node *np;
+  error_t err;
+  struct ufs_fhandle *f;
+
+  if (!cred)
+    return EOPNOTSUPP;
+
+  if (!diskfs_isuid (0, cred))
+    return EPERM;
+  
+  np = cred->po->np;
+
+  mutex_lock (&np->lock);
+
+  if (*fh_len < sizeof (struct ufs_fhandle))
+    vm_allocate (mach_task_self (), (vm_address_t *) fh, 
+		 sizeof (struct ufs_fhandle), 1);
+  *fh_len = sizeof (struct ufs_fhandle);
+  
+  f = (struct ufs_fhandle *) *fh;
+  f->inum = np->dn->number;
+  f->gen = np->dn_stat.st_gen;
+  f->filler1 = 0;
+  f->filler2[0] = f->filler2[1] = f->filler2[2] = f->filler2[3] = 0;
+  mutex_unlock (&np->lock);
+  return 0;
+}
+
+/* Lookup an NFS file handle */
+error_t
+diskfs_S_fsys_getfile (mach_port_t fsys,
+		       mach_port_t reply,
+		       mach_msg_type_name_t replytype,
+		       uid_t *uids,
+		       u_int nuids,
+		       uid_t *gids,
+		       u_int ngids,
+		       char *handle,
+		       u_int handlelen,
+		       mach_port_t *file,
+		       mach_msg_type_name_t *filetype)
+{
+  struct port_info *pt = ports_lookup_port (diskfs_port_bucket, fsys,
+					    diskfs_control_class);
+  struct node *np;
+  struct ufs_fhandle *f;
+  error_t err;
+  int flags;
+  struct protid fakecred, *newpi;
+  
+  if (!pt)
+    return EOPNOTSUPP;
+
+  if (handlelen != sizeof (struct ufs_fhandle))
+    {
+      ports_port_deref (pt);
+      return EINVAL;
+    }
+
+  f = (struct ufs_fhandle *) handle;
+
+  err = diskfs_cached_lookup (f->inum, &np);
+  if (err)
+    {
+      ports_port_deref (pt);
+      return err;
+    }
+
+  if (np->dn_stat.st_gen != f->gen)
+    {
+      diskfs_nput (np);
+      ports_port_deref (pt);
+      return ESTALE;
+    }
+  
+  /* This call should have a flags arg, but until then... */
+  fakecred.uids = uids;
+  fakecred.gids = gids;
+  fakecred.nuids = nuids;
+  fakecred.ngids = ngids;
+
+  flags = 0;
+  if (!diskfs_access (np, S_IREAD, &fakecred))
+    flags |= O_READ;
+  if (!diskfs_access (np, S_IEXEC, &fakecred))
+    flags |= O_EXEC;
+  if (!diskfs_access (np, S_IWRITE, &fakecred)
+      && !S_ISDIR (np->dn_stat.st_mode)
+      && !diskfs_check_readonly ())
+    flags |= O_WRITE;
+  
+  err = diskfs_create_protid (diskfs_make_peropen (np, flags, MACH_PORT_NULL),
+			      uids, nuids, gids, ngids, &newpi);
+  
+  diskfs_nput (np);
+  ports_port_deref (pt);
+  
+  if (!err)
+    {
+      *file = ports_get_right (newpi);
+      *filetype = MACH_MSG_TYPE_MAKE_SEND;
+    }
+  return err;
 }
 
   
diff -ru hurd-0.0/ufs/ufs.h hurd-0.1/ufs/ufs.h
--- hurd-0.0/ufs/ufs.h	Thu May  9 11:54:08 1996
+++ hurd-0.1/ufs/ufs.h	Fri Aug 16 18:51:18 1996
@@ -36,6 +36,8 @@
 {
   ino_t number;
 
+  int dir_idx;
+
   /* For a directory, this array holds the number of directory entries in
      each DIRBLKSIZE piece of the directory. */
   int *dirents;
Only in hurd-0.1: ufs-fsck
diff -ru hurd-0.0/ufs-utils/ChangeLog hurd-0.1/ufs-utils/ChangeLog
--- hurd-0.0/ufs-utils/ChangeLog	Mon Jul 29 12:40:25 1996
+++ hurd-0.1/ufs-utils/ChangeLog	Thu Sep  5 11:44:53 1996
@@ -1,3 +1,12 @@
+Thu Sep  5 11:44:38 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* mkfs.c: Include <version.h>.
+	(argp_program_version): Define with STANDARD_HURD_VERSION.
+
+Mon Aug 19 15:18:30 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* mkfs.c (doc): Supply a useful value.
+
 Tue Jul 23 19:34:58 1996  Miles Bader  <miles@gnu.ai.mit.edu>
 
 	* mkfs.c (fsinit): `struct timespec' now uses a field prefix of `tv_'.
diff -ru hurd-0.0/ufs-utils/mkfs.c hurd-0.1/ufs-utils/mkfs.c
--- hurd-0.0/ufs-utils/mkfs.c	Mon Jul 29 12:40:27 1996
+++ hurd-0.1/ufs-utils/mkfs.c	Thu Sep  5 12:59:14 1996
@@ -33,7 +33,7 @@
 
 #ifndef lint
 /*static char sccsid[] = "from: @(#)mkfs.c	8.3 (Berkeley) 2/3/94";*/
-static char *rcsid = "$Id: mkfs.c,v 1.13 1996/07/23 23:37:21 miles Exp $";
+static char *rcsid = "$Id: mkfs.c,v 1.15 1996/09/05 16:59:14 thomas Exp $";
 #endif /* not lint */
 
 #include <unistd.h>
@@ -54,6 +54,7 @@
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <dirent.h>
+#include <version.h>
 
 #include <device/device_types.h>
 #include <device/disk_status.h>
@@ -163,7 +164,7 @@
 int	fsi, fso;
 daddr_t	alloc();
 
-char *argp_program_version = "mkfs.ufs 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (mkfs.ufs);
 
 #define _STRINGIFY(arg) #arg
 #define STRINGIFY(arg) _STRINGIFY (arg)
@@ -219,7 +220,7 @@
   {0, 0}
 };
 static char *args_doc = "DEVICE";
-static char *doc = 0;
+static char *doc = "Write a ufs filesystem image onto DEVICE.";
 
 struct amark { void *addr; struct amark *next; };
 
diff -ru hurd-0.0/utils/ChangeLog hurd-0.1/utils/ChangeLog
--- hurd-0.0/utils/ChangeLog	Thu Aug  1 12:03:41 1996
+++ hurd-0.1/utils/ChangeLog	Thu Sep  5 12:20:26 1996
@@ -1,3 +1,54 @@
+Thu Sep  5 11:45:58 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* Makefile: Use $(top_srcdir)/sh-version.h to make executables
+ 	from .sh files.
+
+	* fsysopts.c: Include <version.h>.
+	(argp_program_version): Define with STANDARD_HURD_VERSION.
+	* w.c: Likewise.
+	* vmstat.c: Likewise.
+	* vminfo.c: Likewise.
+	* sync.c: Likewise.
+	* storeinfo.c: Likewise.
+	* showtrans.c: Likewise.
+	* settrans.c: Likewise.
+	* ps.c: Likewise.
+	* portinfo.c: Likewise.
+	* login.c: Likewise.
+	* hurdids.c: Likewise.
+
+Sun Sep  1 14:15:46 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* sync.c (argp_program_version): New variable.
+	(main): Call argp_parse with just a doc string.
+	<argp.h>: New include.
+	* Makefile (sync): Depend on libshouldbeinlibc.a.
+
+Fri Aug 30 16:54:57 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* vminfo.c: New file.
+	* Makefile (targets): Add vminfo.
+	(SRCS): Add vminfo.c.
+	(INSTALL-vminfo-ops): New variable.
+
+Mon Aug 19 15:19:20 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* devprobe.c, fsysopts.c, hurdids.c, login.c, portinfo.c, ps.c,
+ 	settrans.c, showtrans.c, storeinfo.c, vmstat.c, w.c, x.c (doc):
+ 	Add program description.
+
+Wed Aug 14 10:18:41 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* Makefile (login-LDLIBS): New variable.
+	(login): Dependency on -lutil removed.
+	(libutil-libsubst): Variable removed.
+
+Sat Aug 10 10:03:57 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* ps.c (options): Whoops, short option for --sort is -s.
+
+	* Makefile (LCLHDRS): New variable.
+
 Wed Jul 31 14:23:31 1996  Miles Bader  <miles@gnu.ai.mit.edu>
 
 	* login.c (main/verify_passwd): Use #pragma weak instead of
diff -ru hurd-0.0/utils/Makefile hurd-0.1/utils/Makefile
--- hurd-0.0/utils/Makefile	Mon Jul 29 12:40:50 1996
+++ hurd-0.1/utils/Makefile	Thu Sep  5 12:22:16 1996
@@ -20,34 +20,33 @@
 
 targets = shd ps settrans showtrans sync su mount fsysopts \
 	storeinfo login w uptime hurdids loginpr sush vmstat portinfo \
-	devprobe 
+	devprobe vminfo
 special-targets = mount loginpr sush uptime
 SRCS = shd.c ps.c su.c settrans.c sync.c showtrans.c \
 	mount.sh fsysopts.c storeinfo.c login.c loginpr.sh sush.sh w.c \
-	uptime.sh psout.c hurdids.c vmstat.c portinfo.c devprobe.c
+	uptime.sh psout.c hurdids.c vmstat.c portinfo.c devprobe.c vminfo.c
+LCLHDRS = psout.h
 
 OBJS = $(filter-out loginpr.sh mount.sh sush.sh uptime.sh,$(SRCS:.c=.o))
-
-# This hack to get around ickiness in Makeconf
-libutil-libsubst = -lutil
+login-LDLIBS = -lutil
 
 INSTALL-login-ops = -o root -m 4755
 INSTALL-ps-ops = -o root -m 4755
 INSTALL-w-ops = -o root -m 4755
 INSTALL-vmstat-ops = -o root -m 4755
+INSTALL-vminfo-ops = -o root -m 4755
 
 include ../Makeconf
 
-login: -lutil     # /gd4/hurdinst/lib/libutil.a	# ick ick ick ick
 ps w: psout.o ../libps/libps.a ../libihash/libihash.a
 storeinfo: ../libstore/libstore.a
 # We must include libthreads because of a bug in the way shared libraries
 # work: all libraries that *any* routine in libfshelp uses must be defined.
 settrans: ../libfshelp/libfshelp.a ../libports/libports.a ../libthreads/libthreads.a
-ps w hurdids settrans showtrans fsysopts storeinfo login vmstat portinfo \
-  devprobe: ../libshouldbeinlibc/libshouldbeinlibc.a
+ps w hurdids settrans sync showtrans fsysopts storeinfo login vmstat portinfo \
+  devprobe vminfo: ../libshouldbeinlibc/libshouldbeinlibc.a
 
 %: %.sh
-	cp $< $@
+	sed -f $(top_srcdir)/sh-version.sed < $< > $@
 
 $(filter-out $(special-targets), $(targets)): %: %.o
diff -ru hurd-0.0/utils/devprobe.c hurd-0.1/utils/devprobe.c
--- hurd-0.0/utils/devprobe.c	Sat May 11 01:03:23 1996
+++ hurd-0.1/utils/devprobe.c	Tue Sep  3 10:21:24 1996
@@ -33,7 +33,8 @@
   {0}
 };
 static const char *args_doc = "DEVNAME...";
-static const char *doc = "The exit status is 0 if any devices were found.";
+static const char *doc = "Test for the existance of mach device DEVNAME..."
+  "\vThe exit status is 0 if any devices were found.";
 
 int
 main (int argc, char **argv)
diff -ru hurd-0.0/utils/fsysopts.c hurd-0.1/utils/fsysopts.c
--- hurd-0.0/utils/fsysopts.c	Mon Jul 29 12:40:52 1996
+++ hurd-0.1/utils/fsysopts.c	Thu Sep  5 11:45:56 1996
@@ -28,10 +28,11 @@
 
 #include <error.h>
 #include <argz.h>
+#include <version.h>
 
 #include <hurd/fsys.h>
 
-char *argp_program_version = "fsysopts 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (fsysopts);
 
 static struct argp_option options[] =
 {
@@ -40,7 +41,8 @@
   {0, 0, 0, 0}
 };
 static char *args_doc = "FILESYS [FS_OPTION...]";
-static char *doc = "The legal values for FS_OPTION depends on FILESYS, but\
+static char *doc = "Get or set command line options for running translator FILESYS."
+"\vThe legal values for FS_OPTION depends on FILESYS, but\
  some common ones are: --readonly, --writable, --remount, --sync[=INTERVAL],\
  and --nosync.\n\nIf no options are supplied, FILESYS's existing options\
  are printed";
diff -ru hurd-0.0/utils/hurdids.c hurd-0.1/utils/hurdids.c
--- hurd-0.0/utils/hurdids.c	Sat Jul  6 19:07:11 1996
+++ hurd-0.1/utils/hurdids.c	Thu Sep  5 11:46:38 1996
@@ -26,11 +26,12 @@
 #include <unistd.h>
 #include <pwd.h>
 #include <grp.h>
+#include <version.h>
 
 #include <error.h>
 #include <hurd/id.h>
 
-char *argp_program_version = "hurdids 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (hurdids);
 
 static struct argp_option options[] =
 {
@@ -43,7 +44,7 @@
   {0}
 };
 static char *args_doc = 0;
-static char *doc = 0;
+static char *doc = "Show hurd uids/gids.";
 
 /* ---------------------------------------------------------------- */
 
diff -ru hurd-0.0/utils/login.c hurd-0.1/utils/login.c
--- hurd-0.0/utils/login.c	Thu Aug  1 12:03:42 1996
+++ hurd-0.1/utils/login.c	Thu Sep  5 11:47:12 1996
@@ -31,6 +31,7 @@
 #include <netdb.h>
 #include <time.h>
 #include <assert.h>
+#include <version.h>
 
 #include <netinet/in.h>
 #include <arpa/inet.h>
@@ -50,7 +51,8 @@
 	     mach_port_t *ports, unsigned num_ports,
 	     mach_port_t *fds, unsigned num_fds);
 
-char *argp_program_version = "login 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (login);
+     
 
 /* Defaults for various login parameters.  */
 char *default_args[] = {
@@ -108,6 +110,7 @@
 };
 static char *args_doc = "[USER [ARG...]]";
 static char *doc =
+"Exec a program with uids and/or the environment changed appropriately.\v"
 "To give args to the shell without specifying a user, use - for USER.\n"
 "Current login parameters include HOME, SHELL, USER, NAME, and ROOT.";
 
diff -ru hurd-0.0/utils/portinfo.c hurd-0.1/utils/portinfo.c
--- hurd-0.0/utils/portinfo.c	Mon Jul 29 12:40:52 1996
+++ hurd-0.1/utils/portinfo.c	Thu Sep  5 11:47:35 1996
@@ -25,6 +25,7 @@
 #include <string.h>
 #include <unistd.h>
 #include <stdlib.h>
+#include <version.h>
 
 #include <mach.h>
 
@@ -34,7 +35,7 @@
 #include <portinfo.h>
 #include <portxlate.h>
 
-char *argp_program_version = "portinfo 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (portinfo);
 
 static const struct argp_option options[] = {
   {0,0,0,0,0, 1},
@@ -72,7 +73,8 @@
 };
 static const char *args_doc = "PID [NAME...]";
 static const char *doc =
-"If no port NAMEs are given, all ports in process PID are reported (if"
+"Show information about mach ports NAME... (default all ports) in process PID."
+"\vIf no port NAMEs are given, all ports in process PID are reported (if"
 " translation is used, then only those common to both processes).  NAMEs"
 " may be specified in hexadecimal or octal by using a 0x or 0 prefix.";
 
diff -ru hurd-0.0/utils/ps.c hurd-0.1/utils/ps.c
--- hurd-0.0/utils/ps.c	Thu Aug  1 12:03:42 1996
+++ hurd-0.1/utils/ps.c	Thu Sep  5 11:47:58 1996
@@ -30,9 +30,11 @@
 #include <idvec.h>
 #include <ps.h>
 #include <error.h>
+#include <version.h>
+
 #include "psout.h"
 
-char *argp_program_version = "ps 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (ps);
 
 #define OA OPTION_ARG_OPTIONAL
 
@@ -75,7 +77,7 @@
                                       " (which defaults to the sid of the"
                                       " current process)"},
   {"sid",        0,       0,      OPTION_ALIAS | OPTION_HIDDEN},
-  {"sort",       'S',	  "FIELD",0, "Sort the output with respect to FIELD,"
+  {"sort",       's',	  "FIELD",0, "Sort the output with respect to FIELD,"
                                      " backwards if FIELD is prefixed by `-'"},
   {"threads",    'T',     0,      0,  "Show the threads for each process"},
   {"tty",        't',     "TTY",  OA, "Only show processes with controlling"
@@ -90,10 +92,10 @@
 };
 
 char *args_doc = "[PID...]";
-
-char *doc = "The USER, LID, PID, PGRP, and SID arguments may also be comma \
-separated lists.  The System V options -u and -g may be accessed with -O and \
---pgrp.";
+char *doc =
+"Show information about processes PID... (default all `interesting' processes)"
+"\vThe USER, LID, PID, PGRP, and SID arguments may also be comma separated"
+" lists.  The System V options -u and -g may be accessed with -O and -G."; 
 
 int 
 parse_enum(char *arg, char **choices, char *kind, int allow_mismatches)
Only in hurd-0.1/utils: psout.h
diff -ru hurd-0.0/utils/settrans.c hurd-0.1/utils/settrans.c
--- hurd-0.0/utils/settrans.c	Sat Jul 20 11:07:15 1996
+++ hurd-0.1/utils/settrans.c	Thu Sep  5 11:48:20 1996
@@ -29,8 +29,9 @@
 #include <error.h>
 #include <argz.h>
 #include <hurd/fshelp.h>
+#include <version.h>
 
-char *argp_program_version = "settrans 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (settrans);
 
 #define DEFAULT_TIMEOUT 60
 
@@ -61,7 +62,8 @@
   {0, 0}
 };
 static char *args_doc = "NODE [TRANSLATOR ARG...]";
-static char *doc = "By default the passive translator is set.";
+static char *doc = "Set the passive/active translator on NODE."
+"\vBy default the passive translator is set.";
 
 /* ---------------------------------------------------------------- */
 
diff -ru hurd-0.0/utils/showtrans.c hurd-0.1/utils/showtrans.c
--- hurd-0.0/utils/showtrans.c	Sat Jul  6 19:07:18 1996
+++ hurd-0.1/utils/showtrans.c	Thu Sep  5 11:48:42 1996
@@ -25,11 +25,12 @@
 #include <argp.h>
 #include <fcntl.h>
 #include <unistd.h>
+#include <version.h>
 
 #include <error.h>
 #include <argz.h>
 
-char *argp_program_version = "showtrans 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (showtrans);
 
 static struct argp_option options[] =
 {
@@ -42,9 +43,9 @@
 };
 
 static char *args_doc = "FILE...";
-
-static char *doc = "A FILE argument of `-' prints the translator on the node \
-attached to standard input.";
+static char *doc = "Show the passive translator of FILE..."
+"\vA FILE argument of `-' prints the translator on the node"
+" attached to standard input.";
 
 /* ---------------------------------------------------------------- */
 
diff -ru hurd-0.0/utils/storeinfo.c hurd-0.1/utils/storeinfo.c
--- hurd-0.0/utils/storeinfo.c	Sat Jul  6 19:07:32 1996
+++ hurd-0.1/utils/storeinfo.c	Thu Sep  5 11:49:06 1996
@@ -25,13 +25,14 @@
 #include <argp.h>
 #include <unistd.h>
 #include <sys/fcntl.h>
+#include <version.h>
 
 #include <error.h>
 
 #include <hurd/fs.h>
 #include <hurd/store.h>
 
-char *argp_program_version = "storeinfo 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (storeinfo);
 
 static struct argp_option options[] =
 {
@@ -48,7 +49,8 @@
   {0, 0}
 };
 static char *args_doc = "FILE...";
-static char *doc = "With no FILE arguments, the file attached to standard \
+static char *doc = "Show information about storage used by FILE..."
+"\vWith no FILE arguments, the file attached to standard \
 input is used.  The fields to be printed are separated by colons, in this \
 order: PREFIX: KIND: NAME: BLOCK-SIZE: BLOCKS: SIZE: RUNS.  If the store is a \
 composite one and --children is specified, children are printed on lines \
diff -ru hurd-0.0/utils/sync.c hurd-0.1/utils/sync.c
--- hurd-0.0/utils/sync.c	Thu Jul  6 22:58:50 1995
+++ hurd-0.1/utils/sync.c	Thu Sep  5 11:49:32 1996
@@ -1,5 +1,5 @@
 /* Call sync synchronously.
-   Copyright (C) 1994, 1995 Free Software Foundation, Inc.
+   Copyright (C) 1994, 1995, 1996 Free Software Foundation, Inc.
    Written by Michael I. Bushnell.
 
    This file is part of the GNU Hurd.
@@ -19,10 +19,17 @@
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
 
 #include <hurd.h>
+#include <argp.h>
+#include <version.h>
+
+char *argp_program_version = STANDARD_HURD_VERSION (sync);
 
 int
-main ()
+main (int argc, char *argv[])
 {
+  struct argp argp =
+    {0, 0, 0, "Force all pending disk writes to be done immediately"};
+  argp_parse (&argp, argc, argv, 0, 0, 0);
   __USEPORT (CRDIR, __file_syncfs (port, 1, 1));
   return 0;
 }
Only in hurd-0.1/utils: vminfo.c
diff -ru hurd-0.0/utils/vmstat.c hurd-0.1/utils/vmstat.c
--- hurd-0.0/utils/vmstat.c	Mon Jul 29 12:40:54 1996
+++ hurd-0.1/utils/vmstat.c	Thu Sep  5 11:50:33 1996
@@ -25,13 +25,14 @@
 #include <string.h>
 #include <unistd.h>
 #include <stdlib.h>
+#include <version.h>
 
 #include <mach.h>
 #include <mach/vm_statistics.h>
 #include <mach/default_pager.h>
 #include <hurd.h>
 
-char *argp_program_version = "vmstat 1.1 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (vmstat);
 
 static const struct argp_option options[] = {
   {"terse",	't', 0, 0, "Use short one-line output format", 1 },
@@ -48,7 +49,8 @@
   {0}
 };
 static const char *args_doc = "[PERIOD [COUNT [HEADER_INTERVAL]]]";
-static const char *doc = "If PERIOD is supplied, then terse mode is"
+static const char *doc = "Show system virtual memory statistics"
+"\vIf PERIOD is supplied, then terse mode is"
 " selected, and the output repeated every PERIOD seconds, with cumulative"
 " fields given the difference from the last output.  If COUNT is given"
 " and non-zero, only that many lines are output.  HEADER_INTERVAL"
diff -ru hurd-0.0/utils/w.c hurd-0.1/utils/w.c
--- hurd-0.0/utils/w.c	Thu Aug  1 12:03:42 1996
+++ hurd-0.1/utils/w.c	Thu Sep  5 11:50:57 1996
@@ -29,6 +29,7 @@
 #include <pwd.h>
 #include <grp.h>
 #include <netdb.h>
+#include <version.h>
 
 #include <sys/fcntl.h>
 
@@ -48,7 +49,7 @@
 extern char *shared_domain (char *host1, char *host2);
 extern char *localhost ();
 
-char *argp_program_version = "w 1.0 (GNU " HURD_RELEASE ")";
+char *argp_program_version = STANDARD_HURD_VERSION (w);
 
 #define OA OPTION_ARG_OPTIONAL
 
@@ -71,7 +72,7 @@
   {0, 0}
 };
 static char *args_doc = "[USER...]";
-static char *doc = 0;
+static char *doc = "Show logged in users and what they are doing";
 
 /* The current time of day.  */
 static struct timeval now;
Only in hurd-0.1: version.h
